# -*- coding: utf-8 -*-
"""
输入输出 - 1, 错误处理=None):

print() & 打印()
input() & 输入()
open()  & 打开文件()
read()  & 读取()
write() & 写入()
flush() & 刷新()
close() & 关闭()

作者: [Tech#6]
版本: 0.0.1
许可证: MIT
"""


def 打印(*对象列表, 分隔符=' ', 结束符='\n', 文件=None, 刷新=False):
    """
    参数：
        对象列表 (any): 要打印的对象列表。
        分隔符 (str, optional): 对象之间的分隔符，默认为空格。
        结束符 (str, optional): 打印结束后的字符，默认为换行符。
        文件 (file, optional): 输出的文件对象，默认为None（标准输出）。
        刷新 (bool, optional): 是否强制刷新输出，默认为False。
    示例：
        打印('你好', '世界')  # 输出：你好 世界
    返回值：
        None: 该函数没有返回值。
    """
    print(*对象列表, sep=分隔符, end=结束符, file=文件, flush=刷新)


def 输入(提示信息=''):
    """
    参数：
        提示信息 (str, optional): 显示给用户的提示信息，默认为空字符串。
    示例：
        用户输入 = 输入('请输入您的名字：')  # 显示提示并等待用户输入
    返回值：
        str: 用户输入的字符串。
    """
    return input(提示信息)


def 打开文件(文件路径, 模式='r', 编码=None, 缓冲=-1, 错误处理=None):
    """
    参数：
        文件路径 (str): 要打开的文件路径。
        模式 (str, optional): 文件打开模式，默认为'r'（只读）。
        编码 (str, optional): 文件编码，默认为None。
        缓冲 (int, optional): 缓冲策略，默认为-1（系统默认缓冲）。
        错误处理 (str, optional): 编码错误处理方式，默认为None。
    示例：
        文件 = 打开文件('example.txt', 模式='w', 编码='utf-8')  # 以写入模式打开文件
    返回值：
        file: 返回文件对象。
    """
    return open(文件路径, mode=模式, encoding=编码, buffering=缓冲, errors=错误处理)


def 读取(文件对象, 大小=-1):
    """
    参数：
        文件对象 (file): 已打开的文件对象。
        大小 (int, optional): 要读取的字节数，默认为-1（读取全部内容）。
    示例：
        内容 = 读取(文件)  # 读取文件全部内容
    返回值：
        str/bytes: 返回读取的内容，根据文件打开模式可能是字符串或字节。
    """
    return 文件对象.read(大小)


def 写入(文件对象, 文本):
    """
    参数：
        文件对象 (file): 已打开的文件对象。
        文本 (str/bytes): 要写入的内容。
    示例：
        写入(文件, '这是要写入的内容')  # 将文本写入文件
    返回值：
        int: 返回写入的字符数。
    """
    return 文件对象.write(文本)


def 刷新(文件对象):
    """
    参数：
        文件对象 (file): 已打开的文件对象。
    示例：
        刷新(文件)  # 强制将缓冲区内容写入文件
    返回值：
        None: 该函数没有返回值。
    """
    文件对象.flush()


def 关闭(文件对象):
    """
    参数：
        文件对象 (file): 已打开的文件对象。
    示例：
        关闭(文件)  # 关闭文件，释放资源
    返回值：
        None: 该函数没有返回值。
    """
    文件对象.close()